Subject: Re: PF_RING: Include in main line kernel?

From: Eric Dumazet <[email-masked]>
Date: Thu, 15 Oct 2009 02:25:33 +0200

David Miller a écrit :
> From: Luca Deri <[email-masked]>
> Date: Wed, 14 Oct 2009 22:17:30 +0200
> 
>> Another reason, is that having a hook in dev.c, device drivers can
>> pass PF_RING packets directly without going through the standard
>> kernel mechanisms. For instance I have developed some drivers that if
>> they detect the presence of PF_RING, pass received packets directly to
>> PF_RING instead of going with NAPI.
> 
> There is absolutely no reason to do this.
> 
> If the existing infrastructure isn't good or fast enough,
> fix it, don't bypass it.

Indeed. IMHO PF_RING seems a huge pile of hacks to me, that would need
a lot of cleanup work before inclusion.

I had problems with past af_packet mmap implementation on ia32, because
not enough high order pages where available in lowmem.

"tcpdump -s 0" could trigger OOM conditions on loaded machines, not sure
it is still the case after commit 719bfeaae8104fca4ca5d47c02592b08682f14fa
(packet: avoid warnings when high-order page allocation fails)

If mmap() can only use 4K pages, are we still able to capture >4K packets ?

I'll check this.